Package org.eclipse.lemminx.services.extensions.completion

## Interface ICompletionParticipant

All Known Implementing Classes:
  `CompletionParticipantAdapter`, `ContentModelCompletionParticipant`, `EntitiesCompletionParticipant`, `FilePathCompletionParticipant`, `PrologCompletionParticipant`, `RNGCompletionParticipant`, `XMLReferencesCompletionParticipant`, `XSDCompletionParticipant`, `XSICompletionParticipant`

    public interface ICompletionParticipant

Completion participant API.

### Method Summary

All Methods Instance Methods Abstract Methods Default Methods
`default ICompletionItemResolveParticipant` `getResolveCompletionItemParticipant​(String participantId)` Returns the completion item resolver that corresponds to the given participant id or null otherwise.
`void` `onAttributeName​(boolean generateValue, ICompletionRequest request, ICompletionResponse response, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)`
`void` `onAttributeValue​(String valuePrefix, ICompletionRequest request, ICompletionResponse response, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)` Collects and stores attribute value completion items within the provided completion response `response`
`void` `onDTDSystemId​(String valuePrefix, ICompletionRequest request, ICompletionResponse response, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)` Collects and stores systemId completion items within the provided completion response `response`
`void` `onTagOpen​(ICompletionRequest completionRequest, ICompletionResponse completionResponse, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)`
`void` `onXMLContent​(ICompletionRequest request, ICompletionResponse response, org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)`

### Method Detail

#### onTagOpen

    void onTagOpen​(ICompletionRequest completionRequest,
                   ICompletionResponse completionResponse,
                   org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)
            throws Exception

Throws:
  `Exception`

#### onXMLContent

    void onXMLContent​(ICompletionRequest request,
                      ICompletionResponse response,
                      org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)
               throws Exception

Throws:
  `Exception`

#### onAttributeName

    void onAttributeName​(boolean generateValue,
                         ICompletionRequest request,
                         ICompletionResponse response,
                         org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)
                  throws Exception

Throws:
  `Exception`

#### onAttributeValue

    void onAttributeValue​(String valuePrefix,
                          ICompletionRequest request,
                          ICompletionResponse response,
                          org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)
                   throws Exception

Collects and stores attribute value completion items within the provided completion response `response`

Parameters:
  `valuePrefix` - the attribute value before the offset in which completion was invoked
  `request` - the completion request
  `response` - the completion response
Throws:
  `Exception`

#### onDTDSystemId

    void onDTDSystemId​(String valuePrefix,
                       ICompletionRequest request,
                       ICompletionResponse response,
                       org.eclipse.lsp4j.jsonrpc.CancelChecker cancelChecker)
                throws Exception

Collects and stores systemId completion items within the provided completion response `response`

Parameters:
  `valuePrefix` - the systemId value before the offset in which completion was invoked
  `request` - the completion request
  `response` - the completion response
Throws:
  `Exception`

#### getResolveCompletionItemParticipant

    default ICompletionItemResolveParticipant getResolveCompletionItemParticipant​(String participantId)

Returns the completion item resolver that corresponds to the given participant id or null otherwise.

Parameters:
  `participantId` - the participant id to find the completion item resolver for
Returns:
  the completion item resolver that corresponds to the given participant id or null otherwise